<?php

	# To define a custom path to ImageMagick or FFMPEG,
	# edit the lines below
	#
	# ex. $path_to_imagemagick = '/usr/bin/convert';
	# ex. $path_to_ffmpeg = '/usr/bin/ffmpeg';
	#
	# For the exact path, check with your host

	$path_to_imagemagick = '';
	$path_to_ffmpeg = '';

	# DO NOT EDIT BELOW THIS LINE

	if (empty($path_to_imagemagick)) {
		$path_to_imagemagick = 'convert';
	} 

	if (empty($path_to_ffmpeg)) {
		$path_to_ffmpeg = 'ffmpeg';
	}

	error_reporting(0);
	
	if (!isset($director)) {
		header('Location: index.php');
	}
	
	if (!isset($_GET['step'])) {
		$step = 1;
	} else {
		$step = $_GET['step'];
	}

	$table_guts = '';
	$warnings = 0;
	$fatals = 0;
	$warning_msg = array();
	$fatal_msg = array();
	
	function process_tests($tests) {
		global $table_guts, $warning_msg, $fatal_msg, $fatals, $warnings;
		foreach($tests as $test) {
			$i = "<tr><td class=\"title\">{$test['desc']}</td>";
			if ($test['test']) { 
				if (!isset($test['msg'])) {
					$test['msg'] = 'Yes';
				}
				$i .= '<td class="pass">' . $test['msg'] . '</td>';
			} else {
				if (!isset($test['msg'])) {
					$test['nomsg'] = 'No';
				}
				$i .= '<td class="fail">' . $test['nomsg'] . '</td>';
				$fatals++;
				array_push($fatal_msg, $test['failmsg']);
			}
			$i .= "</tr>"; 
			$table_guts .= $i;
		}
	}
	
	function ping($action, $post) {
		$pinger = "X-director-ping: $action";
		if (in_array('curl', get_loaded_extensions())) {
			$handle	= curl_init("http://www.sspdirector.com/");
			curl_setopt($handle, CURLOPT_HTTPHEADER, array($pinger));
			curl_setopt($handle, CURLOPT_CONNECTTIMEOUT, 15);
			curl_setopt($handle, CURLOPT_PORT, 80);
			curl_setopt($handle, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($handle, CURLOPT_POST, true);
			curl_setopt($handle, CURLOPT_POSTFIELDS, $post);
			$response = curl_exec($handle);
			if (curl_errno($handle)) {
				$error = 'Could not connect to sspdirector.com (using cURL): ' . curl_error($handle);
			}
			curl_close($handle);
		} else {
			$headers = "POST / HTTP/1.0\r\n";
			$headers .= "Host: www.sspdirector.com\r\n";
			$headers .= "Content-type: application/x-www-form-urlencoded\r\n";
			$headers .= "Content-length: " . strlen($post) . "\r\n";
			$headers .= "\r\n";
			
			$socket = fsockopen('www.sspdirector.com', 80, $errno, $errstr, 15);

			if ($socket) {
				fwrite($socket, $headers.$post."\r\nConnection: Close\r\n\r\n");
				$response = '';
				while (!feof($socket)) {
					$response .= fgets ($socket, 1024);
				}
				$response = explode("\r\n\r\n", $response, 2);
				$response = trim($response[1]);
			} else {
				$error = 'Could not connect to sspdirector.com (using fsockopen): '.$errstr.' ('.$errno.')';
				$response = 'FAILED';
			}
		}
		if ($response != 'SUCCESS') {
			if (isset($error)) {
				return $error;
			} else {
				return true;
			}
		} else {
			return false;
		}
	}

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
<title>SlideShowPro Director: Server compatibility test</title>
<link rel="stylesheet" href="http://install.slideshowpro.net/c.css" type="text/css" />
</head>
<body>

		<div id="login-container">

			<div id="login-content">

				<div class="out-module">

					<div class="wrap">

						<div class="out-module-logo"></div>  
						
						<?php if ($step == 1): ?>
						<ul id="process">
							<li class="first active"><span>Step 1: Essentials</span></li>
							<li><span>Step 2: Recommended setup</span></li>
							<li class=""><span>Step 3: Authentication</span></li>
						</ul>
						<?php elseif ($step == 2): ?>
						<ul id="process">
							<li class="first prevactive"><span>Step 1: Essentials</span></li>
							<li class="active"><span>Step 2: Recommended setup</span></li>
							<li class=""><span>Step 3: Authentication</span></li>
						</ul>
						<?php else: ?>
						<ul id="process">
							<li class="first complete"><span>Step 1: Essentials</span></li>
							<li class="prevactive"><span>Step 2: Recommended setup</span></li>
							<li class="active"><span>Step 3: Authentication</span></li>
						</ul>
						<?php endif; ?> 
						
						<br clear="all" />  

						<div class="content">

						
							<?php
							
							switch ($step):
								case 1:
							?>
							
							<?php
								if (version_compare(PHP_VERSION, '5.0.0', '<')) {
									$overload = function_exists('overload');
								} else {
									$overload = true;
								}
								
								if (DIRECTORY_SEPARATOR == '/' && function_exists('exec')) {
									$path = trim(shell_exec("which $path_to_imagemagick"), "\n ");
									if (is_executable($path)) {
										$magick = true;
									} else {
										$magick = false;
									}
								} else {
									$magick = false;
								}
								
								$tests = array (0 => array ("desc" => "PHP version 4.3.7 or higher (excluding 4.3.10 and 5.0.x)",
											    "test" => (version_compare(PHP_VERSION, '4.3.7', 'ge') && PHP_VERSION != '4.3.10' && substr(PHP_VERSION, 0, 3) != '5.0'),
											    "msg"  => PHP_VERSION,
												"nomsg" => PHP_VERSION,
												"failmsg" => "Director requires a version of PHP greater than 4.3.7. The following versions of PHP are also not supported due to problems specific to those releases: 4.3.10 and 5.0.x",
											    "sev" => 1),
					  					1 => array ("desc" => "MySQL enabled in PHP",
											    "test" => (extension_loaded('mysql') || extension_loaded('mysqli')),
											    "failmsg" => "PHP must be installed with the MySQL extension loaded",
											    "sev" => 1),    				  				
										2 => array ("desc" => "Safe mode disabled",
											    "test" => (ini_get('safe_mode') == false || ini_get('safe_mode') == '' || strtolower(ini_get('safe_mode')) == 'off'),
											    "failmsg" => "<b>safe_mode</b> must be disabled in php.ini",
											    "sev" => 1),
										3 => array ("desc" => "GD libraries (installed with JPEG support) or ImageMagick",
											    "test" => ((extension_loaded('gd') && (imagetypes() & IMG_JPG)) || $magick),
												"msg"  => ($magick ? 'ImageMagick' : 'GD'),
												"nomsg" => 'No',
											    "failmsg" => "Your server does not have an image manipulation library available. Director supports either the GD library or the ImageMagick library for creating thumbnails and optimized images. This test also fails if GD is compiled, but without JPEG support.",
											    "sev" => 1),
										4 => array ("desc" => "PHP overload() function enabled (or PHP 5)",
											    "test" => ($overload),
											    "failmsg" => "Your server has the overload() function disabled. Director depends on this function and will not work at all without it.",
											    "sev" => 1),
										5 => array ("desc" => "cURL or fsockopen enabled for server to server communication",
												"test" => (extension_loaded('curl') || function_exists('fsockopen')),
												"msg"  => (extension_loaded('curl') ? 'cURL' : 'fsockopen'),
												"failmsg" => "In order for Director to communicate with the activation server and authenticate your install, either the cURL library or the fsockopen PHP function must be enabled",
												"sev" => 1)
										);
								
								process_tests($tests);
							
							?>
							
							
							
							<h1>Server compatibility test: Essentials</h1>
							
							
							<!-- <h6>The essentials</h6> -->
							<!-- <p>First, we'll test the basic requirements your server needs to run Director.</p> -->
							
							<table width="100%" cellspacing="0" cellpadding="0" class="sortable">
									<tr>
										<th class="title">Test</th>
										<th>Result</th>
									</tr>
									<?php echo($table_guts); ?>
							</table>
							
							<?php if ($fatals == 0): ?>
								
								<h4 class="go">So far, so good!</h4>
								<p>Next up, we'll see if your server has those little extras that make Director really go.</p>
							
								<p class="bttn">
									<button class="primary_lg" title="On to step 2" onclick="location.href='?step=2'">On to step 2 &rarr;</button>
								</p>
								
							<?php else: ?>
								
							
							
											<h4 class="no">This server is not compatible with Director. Here's why:</h4>
										
											<ul class="list">
											<?php foreach($fatal_msg as $msg):
												echo("<li>$msg</li>");
											endforeach; ?>
											</ul>
								
								
								
									<p>Contact your web host to correct the issues above, then <a href="index.php?step=1" title="Re-run">rerun this test</a>. Or <a href="http://slideshowpro.net/products/slideshowpro_director/#pricing" title="SSP Director Hosting">signup for our Director subscription service</a>.</p>
							<?php endif; ?>
							
						
							<?php 
							
							break;
							case 2:
							
							if (function_exists('exec') && (DIRECTORY_SEPARATOR == '/' || (DIRECTORY_SEPARATOR == '\\' && $path_to_ffmpeg != 'ffmpeg'))) {
								exec($path_to_ffmpeg . ' -version 2>&1', $out);
								if (empty($out)) {
									$ffmpeg = false;
								} else {
									if (strpos($out[0], 'FFmpeg') !== false) {
										$ffmpeg = true;
									} else {
										$ffmpeg = false;
									}
								}
							} else {
								$ffmpeg = false;
							}
							
							$tests = array(
									1 => array(
										"desc" => "File uploads enabled",
								    	"test" => (ini_get('file_uploads') != ''),
								    	"failmsg" => "Your PHP configuration does not permit file uploads. If this is not resolved, you will only be able to upload your imagery via FTP and not through the Director interface.",
								    	"sev" => 0),
									2 => array(
										"desc" => "IPTC support",
								    	"test" => is_callable('iptcparse'),
								    	"failmsg" => "Your PHP install does not support the parsing of IPTC data, limiting your ability to use the metadata already embedded in your images.",
								    	"sev" => 0),
									3 => array(
										"desc" => "EXIF support",
								    	"test" => is_callable('exif_read_data'),
								    	"failmsg" => "Your PHP install does not support the parsing of EXIF data, limiting your ability to use the metadata already embedded in your images.",
								    	"sev" => 0),
									4 => array(
										"desc" => "FFmpeg support",
								    	"test" => $ffmpeg,
								    	"failmsg" => "Without FFmpeg support, Director will not be able to extract thumbnails from your uploaded videos. You will need to upload thumbnails and assign them through Director's interface.",
								    	"sev" => 0)
								
								);
								
							process_tests($tests);
							
							$table_guts .= '<tr><td class="title">PHP can write to the filesystem</td>';
							if (is_writable(dirname(__FILE__))):
								$table_guts .= '<td class="pass">Yes</td>';
							else:                               
								if (@chmod(dirname(__FILE__), 0777)):
									$table_guts .= '<td class="pass">Yes</td>';
								else:
									$table_guts .= '<td class="fail">No</td>';
									$fatals++;
									array_push($fatal_msg, 'PHP does not have the ability to write files to the filesystem. You may try to change the permissions on the director_test folder to 777 and run the test again. If that does not work, SlideShowPro Director will not be able to write images to the filesystem, limiting its feature set. If you have any questions on how to set permissions, please contact your host.');
								endif;
							endif;
							$table_guts .= "</tr>";
							?>
							
								<h1>Server compatibility test: Recommended setup</h1>

													
							
							<table width="100%" cellspacing="0" cellpadding="0" class="sortable">
									<tr>
										<th class="title">Test</th>
										<th class="tr">Result</th>
									</tr>
									<?php echo($table_guts); ?>
							</table>
							
								<?php if ($fatals == 0): ?>

									<h4 class="go">Everything looks good!</h4>
									<p>For our last test, we'll make sure that your server can contact the activation server in order to authenticate your installation and receive automatic updates.</p>

									<p class="bttn">
										<button class="primary_lg" onclick="location.href='?step=3'">One more step &rarr;</button>
									</p>

								<?php else: ?>

					
												<h4 class="warn">This server is compatible with Director, but with limitations:</h4>
												
												<ul class="list">
												<?php foreach($fatal_msg as $msg):
													echo("<li>$msg</li>");
												endforeach; ?>
												</ul>
												
												

									

									<p>Director will still function on this server, but its features will be limited as described above. If you'd like, you can continue to the last step of the test.</p>
								
									<p class="bttn">
										<button class="primary_lg" onclick="location.href='?step=3&amp;errors=1'">One more step &rarr;</button>
									</p>
								<?php endif; ?>
								
							<?php 
							
							break;
							default:
							
							 ?>
							
								<h1>Server compatibility test: Authentication</h1>

							
							
							<?php $result = ping('Test Ping', 'testing=1'); ?>
							
							<table width="100%" cellspacing="0" cellpadding="0" class="sortable">
									<tr>
										<th class="title">Test</th>
										<th>Result</th>
									</tr>
									<tr>
										<td class="title">Connection to activation server</td>
										<?php if (!$result): ?>
										<td class="pass">Yes</td>
										<?php else: ?>
										<td class="fail">No</td>
										<?php endif ?>
									</tr>
							</table>
							
							<?php if (!$result): ?>
								
								<?php if (isset($_GET['errors'])): ?>
									
									<h4 class="go">Your server is compatible, but with limitations.</h4>
									
									<p>SlideShowPro Director can be installed and used on this web server, but <a href="?step=2" title="Step 2">without the features noted in Step 2</a>.</p>
									
									<p class="bttn">
									
										<button title="Grab a copy of Director now" class="primary_lg" onclick="location.href='http://slideshowpro.net/account_center/signup.php';return false;">Purchase SlideShowPro Director</button>
									</p>
								<?php else: ?>
									<h4 class="go">Your server passed with flying colors!</h4>
									<p>Your server has everything SlideShowPro Director needs. Click the button below to purchase SlideShowPro Director.</p>
									
									<p class="bttn">
										<button class="primary_lg" onclick="location.href='http://slideshowpro.net/account_center/signup.php';return false;" title="Grab a copy of Director now">Purchase SlideShowPro Director</button>
									</p>
								<?php endif; ?>
							<?php else: ?>
								
									<h4 class="no">This server is not compatible with Director. Here's why:</h4>
											
										<ul class="list">
										<li>Director must be able to contact sspdirector.com to authenticate your license and check for product updates. We tried using either the curl library or the fsockopen function of PHP, but failed.<?php if (!is_bool($result)): ?> Specifically, this is the error that occurred:<br /><code><?php echo($result); ?></code><?php endif; ?>
											</li>
										</ul>
											
								<p>
									This may be a temporary glitch between your server and sspdirector.com. Wait a few minutes and <a href="index.php?step=3" title="Try again">try again</a>. If you continue to get this error, you will need to contact your host to resolve this issue before being able to purchase and use SlideShowPro Director.
								</p>
								
							
							<?php endif; ?>
							
							<?php break;?>
							<?php endswitch; ?>
							
							
							
								</div> <!--close content-->

							</div> <!--close module wrap-->

						</div> <!--close module-->
			
			
			
			
			<p class="disclaimer">This test checks for the basic requirements a server must meet to handle an install of SlideShowPro Director. (A different set of browser requirements apply). <em>This does not guarantee that SlideShowPro Director will work on your server, nor does it imply that all features of SlideShowPro Director will function as expected</em>.</p>
			
			<p class="disclaimer">Not passing the test? <a href="http://slideshowpro.net/products/slideshowpro_director/#pricing" title="SlideShowPro Director Hosting" target="_blank">We can host SlideShowPro Director for you</a>.</p>
				
				
		</div> <!--close login-content-->
		
	</div> <!--close login-container-->
	
</body>
</html>